package org.gcube.data.access.fs;

import static org.gcube.common.storagehub.model.Constants.enchriptedPrefix;

import java.io.File;
import java.security.Key;
import java.util.Base64;
import java.util.Calendar;

import javax.inject.Inject;

import org.gcube.common.encryption.StringEncrypter;
import org.gcube.common.encryption.SymmetricKey;
import org.gcube.common.scope.api.ScopeProvider;
import org.gcube.common.storagehub.model.expressions.Expression;
import org.gcube.common.storagehub.model.expressions.GenericSearchableItem;
import org.gcube.common.storagehub.model.expressions.date.Before;
import org.gcube.common.storagehub.model.expressions.logical.And;
import org.gcube.common.storagehub.model.expressions.text.Contains;
import org.gcube.data.access.storagehub.Constants;
import org.gcube.data.access.storagehub.query.sql2.evaluators.Evaluators;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

//@RunWith(WeldJunit4Runner.class)
public class Expressions {
/*
	private static Logger log = LoggerFactory.getLogger(Expression.class);
	
	@Inject 
	Evaluators evaluators;
	
	

	public void test() {
		
		evaluators.getEvaluators().forEach(s-> System.out.println(s.getType().toString()));
		
		Expression<Boolean> cont1 = new Contains(GenericSearchableItem.get().title, "Data");
		Expression<Boolean> before = new Before(GenericSearchableItem.get().creationTime, Calendar.getInstance());
		Expression<Boolean> andExpr = new And(cont1, before);
		System.out.println(evaluators.evaluate(andExpr));
		
	}
	
*/
	@Test
	public void test() throws Exception {
		Key key = SymmetricKey.loadKeyFromFile(new File("/home/lucio/d4science.research-infrastructures.eu.gcubekey"), "AES");
		String idEnc = "E_clNONXlCQlk3aGNMK210eThXbmxXMUFiZXV3NGxqTElFRTlDM21sOFBHbGR5bE9Gc3hVTE9aRTF6T1VlZTF5bw==";
		String id = StringEncrypter.getEncrypter().decrypt(new String(Base64.getUrlDecoder().decode(idEnc.replace(enchriptedPrefix, ""))),key);
		
		System.out.println(id);
	}
	
	
	
}
